/****************************************************************
*  Name    : Control											*
*  Author  : Davide Ferrario                                    *
*  Notice  : Copyright 2011 All Rights Reserved                 *
*  Date    : 14/05/2011                                         *
*  Notes   : Classe gestione visualizzazione grafica stato     	*
*          :													*
****************************************************************/

// Definizione Package
package BlackProject.HouseSpeechDemo;

// Inclusione librerie
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View.OnClickListener;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import java.util.Timer;
import java.util.TimerTask;

// Classe Control del progetto HouseSpeechDemo
public class Control extends Activity implements OnClickListener {
	// Creo nuova classe gestione protocollo ethernet
	private EthernetProtocol ethernetProtocol = new EthernetProtocol();
	
	// Classe gestione lettura stato scheda
	private Lettura_StatoScheda Lettura_StatoScheda_Classe = null;
	
	// Oggetti grafici
	private Button ButtonON1 = null;
	private Button ButtonON2 = null;
	private Button ButtonON3 = null;
	private Button ButtonON4 = null;
	private Button ButtonON5 = null;
	private Button ButtonON6 = null;
	private Button ButtonON7 = null;
	private Button ButtonON8 = null;
	private Button ButtonOFF1 = null;
	private Button ButtonOFF2 = null;
	private Button ButtonOFF3 = null;
	private Button ButtonOFF4 = null;
	private Button ButtonOFF5 = null;
	private Button ButtonOFF6 = null;
	private Button ButtonOFF7 = null;
	private Button ButtonOFF8 = null;
	private Button ButtonTOGGLE1 = null;
	private Button ButtonTOGGLE2 = null;
	private Button ButtonTOGGLE3 = null;
	private Button ButtonTOGGLE4 = null;
	private Button ButtonTOGGLE5 = null;
	private Button ButtonTOGGLE6 = null;
	private Button ButtonTOGGLE7 = null;
	private Button ButtonTOGGLE8 = null;
	
	// Indica se warning segnalato
	// 		false -> warning non segnalato
	//		true -> warning segnalato
	private boolean warningSegnalato = false;
	
	private Timer AggiornamentoGraficaTimer = null;

	private Handler handler = new Handler();
	private Context context = this;

	/** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.control);

        // Warning non segnalato
    	warningSegnalato = false;
    	
    	// Identifico pulsanti
    	ButtonON1 = (Button) findViewById(R.id.ButtonON1);
    	ButtonON2 = (Button) findViewById(R.id.ButtonON2);
    	ButtonON3 = (Button) findViewById(R.id.ButtonON3);
    	ButtonON4 = (Button) findViewById(R.id.ButtonON4);
    	ButtonON5 = (Button) findViewById(R.id.ButtonON5);
    	ButtonON6 = (Button) findViewById(R.id.ButtonON6);
    	ButtonON7 = (Button) findViewById(R.id.ButtonON7);
    	ButtonON8 = (Button) findViewById(R.id.ButtonON8);
    	ButtonON1.setOnClickListener(this);
    	ButtonON2.setOnClickListener(this);
    	ButtonON3.setOnClickListener(this);
    	ButtonON4.setOnClickListener(this);
    	ButtonON5.setOnClickListener(this);
    	ButtonON6.setOnClickListener(this);
    	ButtonON7.setOnClickListener(this);
    	ButtonON8.setOnClickListener(this);
    	
    	ButtonOFF1 = (Button) findViewById(R.id.ButtonOFF1);
    	ButtonOFF2 = (Button) findViewById(R.id.ButtonOFF2);
    	ButtonOFF3 = (Button) findViewById(R.id.ButtonOFF3);
    	ButtonOFF4 = (Button) findViewById(R.id.ButtonOFF4);
    	ButtonOFF5 = (Button) findViewById(R.id.ButtonOFF5);
    	ButtonOFF6 = (Button) findViewById(R.id.ButtonOFF6);
    	ButtonOFF7 = (Button) findViewById(R.id.ButtonOFF7);
    	ButtonOFF8 = (Button) findViewById(R.id.ButtonOFF8);
    	ButtonOFF1.setOnClickListener(this);
    	ButtonOFF2.setOnClickListener(this);
    	ButtonOFF3.setOnClickListener(this);
    	ButtonOFF4.setOnClickListener(this);
    	ButtonOFF5.setOnClickListener(this);
    	ButtonOFF6.setOnClickListener(this);
    	ButtonOFF7.setOnClickListener(this);
    	ButtonOFF8.setOnClickListener(this);

    	ButtonTOGGLE1 = (Button) findViewById(R.id.ButtonTOGGLE1);
    	ButtonTOGGLE2 = (Button) findViewById(R.id.ButtonTOGGLE2);
    	ButtonTOGGLE3 = (Button) findViewById(R.id.ButtonTOGGLE3);
    	ButtonTOGGLE4 = (Button) findViewById(R.id.ButtonTOGGLE4);
    	ButtonTOGGLE5 = (Button) findViewById(R.id.ButtonTOGGLE5);
    	ButtonTOGGLE6 = (Button) findViewById(R.id.ButtonTOGGLE6);
    	ButtonTOGGLE7 = (Button) findViewById(R.id.ButtonTOGGLE7);
    	ButtonTOGGLE8 = (Button) findViewById(R.id.ButtonTOGGLE8);
    	ButtonTOGGLE1.setOnClickListener(this);
    	ButtonTOGGLE2.setOnClickListener(this);
    	ButtonTOGGLE3.setOnClickListener(this);
    	ButtonTOGGLE4.setOnClickListener(this);
    	ButtonTOGGLE5.setOnClickListener(this);
    	ButtonTOGGLE6.setOnClickListener(this);
    	ButtonTOGGLE7.setOnClickListener(this);
    	ButtonTOGGLE8.setOnClickListener(this);
    	
    	// Disabilito grafica tutti rele
    	for (byte ReleNum = 0; ReleNum < 8; ReleNum++)
    		DisabilitaGraficaRele(ReleNum);
    }		// Chiusura funzione onCreate

    // Eseguita quando l'activity viene visualizzata
    @Override
    public void onResume() {
    	super.onResume();

    	// Azzero struttura memorizzazione stato rele
    	StatoScheda.StatoReleAttivo = null;

    	// Warning non segnalato
    	warningSegnalato = false;
    	
    	// Creo/Avvio timer aggiornamento stato scheda
        AggiornamentoGraficaTimer = new Timer();
        AggiornamentoGraficaTimer.schedule(new TimerTask() {
			@Override
			public void run() {
				Aggiornamento_Grafica();
			}
		}, 0, 250);

    	// Avvio thread lettura stato scheda (file status.xml)
		Lettura_StatoScheda_Classe = new Lettura_StatoScheda();    	
    }		// Chiusura funzione onResume

    // Eseguita quando l'activity viene nascosta
	@Override
	public void onPause() {
		// Termino thread lettura stato scheda
		try {
			Lettura_StatoScheda_Classe.stopRunning();
		} catch (Exception e) {}
		
		// Termino timer aggiornamento stato scheda
		try {
			AggiornamentoGraficaTimer.purge();
			AggiornamentoGraficaTimer.cancel();
		} catch (Exception e) {}

		super.onPause();
	}		// Chiusura funzione onPause

    // Eseguita quando l'activity viene terminata
    @Override
    public void onDestroy() {
		// Termino thread lettura stato scheda
		try {
			Lettura_StatoScheda_Classe.stopRunning();
		} catch (Exception e) {}

		// Termino timer aggiornamento stato scheda
		try {
			AggiornamentoGraficaTimer.purge();
			AggiornamentoGraficaTimer.cancel();
		} catch (Exception e) {}

		super.onDestroy();
    }		// Chiusura funzione onDestroy
    
	// Definizione classe Lettura_StatoScheda
	private class Lettura_StatoScheda implements Runnable {
		private Thread Lettura_StatoScheda_Thread = null;
		private boolean Termina_Thread = false;

		// Costruttore classe Lettura_StatoScheda
		private Lettura_StatoScheda() {
			Lettura_StatoScheda_Thread = new Thread(this);
			Lettura_StatoScheda_Thread.start();
		}		// Chiusura costruttore classe Lettura_StatoScheda

		// Funzione esecuzione lettura stato scheda
		public void run() {
			String Risposta;

			// Mentre thread non bloccato
			for (;(Termina_Thread == false);) {
				// Eseguo lettura stato scheda
				Risposta = ethernetProtocol.LetturaStatoScheda();

				// Se ricevuta risposta
				if (Risposta != null) {
					// Estraggo informazioni ricevute
					if (StatoScheda.StatoReleAttivo == null)
						StatoScheda.StatoReleAttivo = new boolean[8];
					
					// Estraggo stato dei led dalla risposta
					for (byte led = 0; led < 8; led++) {
						try {
			   		    	if (Integer.parseInt (Risposta.substring (Risposta.indexOf("<led" + led + ">") + ("<led" + led + ">").length(),
			   		    											  Risposta.indexOf("</led"+ led + ">"))) == 0)
			   		    		StatoScheda.StatoReleAttivo[led] = false;
			   		    	else
			   		    		StatoScheda.StatoReleAttivo[led] = true;
						} catch (Exception e) {}
					}		// Chiusura ciclo for estraggo stato dei led dalla risposta
				}		// Chiusura if ricevuta risposta
				// Se non ricevuta risposta
				else
					// Azzero stato rele
					StatoScheda.StatoReleAttivo = null;
				
				try {
					Thread.sleep (1500);
				} catch (Exception e) {}
			}		// Chiusura ciclo for mentre thread non bloccato
		}		// Chiusura funzione run
		
		// Richiede il termine del thread lettura tipo serrature/stato dei ritardi
		public void stopRunning() {
			Termina_Thread = true;
		}		// Chiusura funzione stopRunning
	}		// Chiusura classe Lettura_StatoScheda
    
	// Funzione richiamata quando viene premuto un pulsante
	public void onClick(View target) {
		// Seleziono ID pulsante premuto
		switch (target.getId()) {
			case R.id.ButtonON1:
				// Avvio thread attivazione rele
				ethernetProtocol.AttivazioneRele ((byte) (0));
				break;
			case R.id.ButtonON2:
				ethernetProtocol.AttivazioneRele ((byte) (1));
				break;
			case R.id.ButtonON3:
				ethernetProtocol.AttivazioneRele ((byte) (2));
				break;
			case R.id.ButtonON4:
				ethernetProtocol.AttivazioneRele ((byte) (3));
				break;
			case R.id.ButtonON5:
				ethernetProtocol.AttivazioneRele ((byte) (4));
				break;
			case R.id.ButtonON6:
				ethernetProtocol.AttivazioneRele ((byte) (5));
				break;
			case R.id.ButtonON7:
				ethernetProtocol.AttivazioneRele ((byte) (6));
				break;
			case R.id.ButtonON8:
				ethernetProtocol.AttivazioneRele ((byte) (7));
				break;
				
			case R.id.ButtonOFF1:
				// Avvio thread disattivazione rele
				ethernetProtocol.DisattivazioneRele ((byte) (0));
				break;
			case R.id.ButtonOFF2:
				// Avvio thread disattivazione rele
				ethernetProtocol.DisattivazioneRele ((byte) (1));
				break;
			case R.id.ButtonOFF3:
				// Avvio thread disattivazione rele
				ethernetProtocol.DisattivazioneRele ((byte) (2));
				break;
			case R.id.ButtonOFF4:
				// Avvio thread disattivazione rele
				ethernetProtocol.DisattivazioneRele ((byte) (3));
				break;
			case R.id.ButtonOFF5:
				// Avvio thread disattivazione rele
				ethernetProtocol.DisattivazioneRele ((byte) (4));
				break;
			case R.id.ButtonOFF6:
				// Avvio thread disattivazione rele
				ethernetProtocol.DisattivazioneRele ((byte) (5));
				break;
			case R.id.ButtonOFF7:
				// Avvio thread disattivazione rele
				ethernetProtocol.DisattivazioneRele ((byte) (6));
				break;
			case R.id.ButtonOFF8:
				// Avvio thread disattivazione rele
				ethernetProtocol.DisattivazioneRele ((byte) (7));
				break;
				
			case R.id.ButtonTOGGLE1:
				// Avvio thread inversione rele
				ethernetProtocol.InversioneRele ((byte) (0));
				break;
			case R.id.ButtonTOGGLE2:
				// Avvio thread inversione rele
				ethernetProtocol.InversioneRele ((byte) (1));
				break;
			case R.id.ButtonTOGGLE3:
				// Avvio thread inversione rele
				ethernetProtocol.InversioneRele ((byte) (2));
				break;
			case R.id.ButtonTOGGLE4:
				// Avvio thread inversione rele
				ethernetProtocol.InversioneRele ((byte) (3));
				break;
			case R.id.ButtonTOGGLE5:
				// Avvio thread inversione rele
				ethernetProtocol.InversioneRele ((byte) (4));
				break;
			case R.id.ButtonTOGGLE6:
				// Avvio thread inversione rele
				ethernetProtocol.InversioneRele ((byte) (5));
				break;
			case R.id.ButtonTOGGLE7:
				// Avvio thread inversione rele
				ethernetProtocol.InversioneRele ((byte) (6));
				break;
			case R.id.ButtonTOGGLE8:
				// Avvio thread inversione rele
				ethernetProtocol.InversioneRele ((byte) (7));
				break;				
		}		// Chiusura switch seleziono ID pulsante premuto
	}		// Chiusura funzione onClick

	// Funzione aggiornamento stato scheda
	private void Aggiornamento_Grafica() {
		// Avvio thread aggiornamento grafica
		handler.post(AggiornamentoGrafica);
	}		// Chiusura funzione Aggiornamento_Grafica

    // Classe gestione aggiornamento grafica
	// INPUT:	-
	// OUTPUT:	-
	// Note:	-
	private Runnable AggiornamentoGrafica = new Runnable() {
		// Funzione esecuzione aggiornamento grafica
		public void run() {
			// Se ultima richiesta HTTP completata
			if (StatoScheda.RisultatoUltimaComunicazione == true) {
				if (StatoScheda.StatoReleAttivo != null) {
					for (byte ReleNum = 0; ReleNum < 8; ReleNum++)
						AggiornaGraficaRele(ReleNum);
				}

				// Warning non segnalato
		    	warningSegnalato = false;
			}		// Chiusura if ultima richiesta HTTP completata
			// Se ultima richiesta HTTP FAULT
			else {
				// Disabilito campi grafici rel
				for (byte ReleNum = 0; ReleNum < 8; ReleNum++)
					DisabilitaGraficaRele(ReleNum);

				// Se warning non segnalato
				if (warningSegnalato == false) {
					// Segnalo segnalazione errore
					Utility.ShowSimpleDialog ("Warning",
											  "Unable to execute WiFi link.\n" +
											  "Check WiFi settings.",
											  R.drawable.iconaerrorealert, context, handler, null);
					// Warning segnalato
					warningSegnalato = true;
				}		// Chiusura if warning non segnalato
			}		// Chiusura else ultima richiesta HTTP FAULT
		}		// Chiusura funzione run
	};		// Chiusura classe AggiornamentoGrafica
	
	// Aggiorna tutti i campi grafici di un rele
	private void AggiornaGraficaRele(byte ReleNum) {
		TextView TextViewStatoRele = null;
		Button ButtonON = null;
		Button ButtonOFF = null;
		Button ButtonTOGGLE= null;

		// Identifico oggetti grafici
		switch (ReleNum) {
			case (byte) (0x00):
				TextViewStatoRele = (TextView) findViewById(R.id.TextViewStatoRele1);
				ButtonON = (Button) findViewById(R.id.ButtonON1);
				ButtonOFF = (Button) findViewById(R.id.ButtonOFF1);
				ButtonTOGGLE = (Button) findViewById(R.id.ButtonTOGGLE1);
				break;
			case (byte) (0x01):
				TextViewStatoRele = (TextView) findViewById(R.id.TextViewStatoRele2);
				ButtonON = (Button) findViewById(R.id.ButtonON2);
				ButtonOFF = (Button) findViewById(R.id.ButtonOFF2);
				ButtonTOGGLE = (Button) findViewById(R.id.ButtonTOGGLE2);
				break;
			case (byte) (0x02):
				TextViewStatoRele = (TextView) findViewById(R.id.TextViewStatoRele3);
				ButtonON = (Button) findViewById(R.id.ButtonON3);
				ButtonOFF = (Button) findViewById(R.id.ButtonOFF3);
				ButtonTOGGLE = (Button) findViewById(R.id.ButtonTOGGLE3);
				break;
			case (byte) (0x03):
				TextViewStatoRele = (TextView) findViewById(R.id.TextViewStatoRele4);
				ButtonON = (Button) findViewById(R.id.ButtonON4);
				ButtonOFF = (Button) findViewById(R.id.ButtonOFF4);
				ButtonTOGGLE = (Button) findViewById(R.id.ButtonTOGGLE4);
				break;
			case (byte) (0x04):
				TextViewStatoRele = (TextView) findViewById(R.id.TextViewStatoRele5);
				ButtonON = (Button) findViewById(R.id.ButtonON5);
				ButtonOFF = (Button) findViewById(R.id.ButtonOFF5);
				ButtonTOGGLE = (Button) findViewById(R.id.ButtonTOGGLE5);
				break;
			case (byte) (0x05):
				TextViewStatoRele = (TextView) findViewById(R.id.TextViewStatoRele6);
				ButtonON = (Button) findViewById(R.id.ButtonON6);
				ButtonOFF = (Button) findViewById(R.id.ButtonOFF6);
				ButtonTOGGLE = (Button) findViewById(R.id.ButtonTOGGLE6);
				break;
			case (byte) (0x06):
				TextViewStatoRele = (TextView) findViewById(R.id.TextViewStatoRele7);
				ButtonON = (Button) findViewById(R.id.ButtonON7);
				ButtonOFF = (Button) findViewById(R.id.ButtonOFF7);
				ButtonTOGGLE = (Button) findViewById(R.id.ButtonTOGGLE7);
				break;
			case (byte) (0x07):
				TextViewStatoRele = (TextView) findViewById(R.id.TextViewStatoRele8);
				ButtonON = (Button) findViewById(R.id.ButtonON8);
				ButtonOFF = (Button) findViewById(R.id.ButtonOFF8);
				ButtonTOGGLE = (Button) findViewById(R.id.ButtonTOGGLE8);
				break;
		}

		// Se rele disattivo
		if (StatoScheda.StatoReleAttivo[ReleNum] == false) {
			TextViewStatoRele.setText("OFF");
			ButtonON.setEnabled(true);
			ButtonOFF.setEnabled(false);
		}
		// Se rele attivo
		else {
			TextViewStatoRele.setText("ON");
			ButtonON.setEnabled(false);
			ButtonOFF.setEnabled(true);
		}
		ButtonTOGGLE.setEnabled(true);
	}		// Chiusura funzione AggiornaGraficaRele

	// Disabilita tutti i campi grafici di un rel
	private void DisabilitaGraficaRele(byte ReleNum) {
		TextView TextViewStatoRele = null;
		Button ButtonON = null;
		Button ButtonOFF = null;
		Button ButtonTOGGLE= null;

		// Identifico oggetti grafici
		switch (ReleNum) {
			case (byte) (0x00):
				TextViewStatoRele = (TextView) findViewById(R.id.TextViewStatoRele1);
				ButtonON = (Button) findViewById(R.id.ButtonON1);
				ButtonOFF = (Button) findViewById(R.id.ButtonOFF1);
				ButtonTOGGLE = (Button) findViewById(R.id.ButtonTOGGLE1);
				break;
			case (byte) (0x01):
				TextViewStatoRele = (TextView) findViewById(R.id.TextViewStatoRele2);
				ButtonON = (Button) findViewById(R.id.ButtonON2);
				ButtonOFF = (Button) findViewById(R.id.ButtonOFF2);
				ButtonTOGGLE = (Button) findViewById(R.id.ButtonTOGGLE2);
				break;
			case (byte) (0x02):
				TextViewStatoRele = (TextView) findViewById(R.id.TextViewStatoRele3);
				ButtonON = (Button) findViewById(R.id.ButtonON3);
				ButtonOFF = (Button) findViewById(R.id.ButtonOFF3);
				ButtonTOGGLE = (Button) findViewById(R.id.ButtonTOGGLE3);
				break;
			case (byte) (0x03):
				TextViewStatoRele = (TextView) findViewById(R.id.TextViewStatoRele4);
				ButtonON = (Button) findViewById(R.id.ButtonON4);
				ButtonOFF = (Button) findViewById(R.id.ButtonOFF4);
				ButtonTOGGLE = (Button) findViewById(R.id.ButtonTOGGLE4);
				break;
			case (byte) (0x04):
				TextViewStatoRele = (TextView) findViewById(R.id.TextViewStatoRele5);
				ButtonON = (Button) findViewById(R.id.ButtonON5);
				ButtonOFF = (Button) findViewById(R.id.ButtonOFF5);
				ButtonTOGGLE = (Button) findViewById(R.id.ButtonTOGGLE5);
				break;
			case (byte) (0x05):
				TextViewStatoRele = (TextView) findViewById(R.id.TextViewStatoRele6);
				ButtonON = (Button) findViewById(R.id.ButtonON6);
				ButtonOFF = (Button) findViewById(R.id.ButtonOFF6);
				ButtonTOGGLE = (Button) findViewById(R.id.ButtonTOGGLE6);
				break;
			case (byte) (0x06):
				TextViewStatoRele = (TextView) findViewById(R.id.TextViewStatoRele7);
				ButtonON = (Button) findViewById(R.id.ButtonON7);
				ButtonOFF = (Button) findViewById(R.id.ButtonOFF7);
				ButtonTOGGLE = (Button) findViewById(R.id.ButtonTOGGLE7);
				break;
			case (byte) (0x07):
				TextViewStatoRele = (TextView) findViewById(R.id.TextViewStatoRele8);
				ButtonON = (Button) findViewById(R.id.ButtonON8);
				ButtonOFF = (Button) findViewById(R.id.ButtonOFF8);
				ButtonTOGGLE = (Button) findViewById(R.id.ButtonTOGGLE8);
				break;
		}

		TextViewStatoRele.setText("");
		ButtonON.setEnabled(false);
		ButtonOFF.setEnabled(false);
		ButtonTOGGLE.setEnabled(false);
	}		// Chiusura funzione DisabilitaGraficaRele
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		MenuInflater inflater = getMenuInflater();
		inflater.inflate(R.menu.option_menu, menu);
		return (true);
	}

	// Richiamata quando viene selezionata una voce del men
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		Intent serverIntent = null;

		// Seleziono voce men premuta
		switch (item.getItemId()) {
			// Se selezionata voce Speech recognition
			case R.id.startriconoscimentovocale:
				// Avvvio activity Riconoscimento Vocale
				serverIntent = new Intent(this, RiconoscimentoVocale.class);
				startActivity(serverIntent);
				// Termino activity
				finish();

				
				/*
			    try {
			    	// Avvio activity riconoscimento vocale
			    	Intent riconoscimentoVocaleIntent = new Intent (context, RiconoscimentoVocale.class);
			    	riconoscimentoVocaleIntent.addFlags(Intent.FLAG_FROM_BACKGROUND);
			    	riconoscimentoVocaleIntent.addFlags(Intent.FLAG_ACTIVITY_SINGLE_TOP);
	                riconoscimentoVocaleIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK); 
			    	context.startActivity (riconoscimentoVocaleIntent);
			    } catch (Exception e) {}
			    */
				
				// Termino funzione
				return (true);

			// Se selezionata la voce Setting
			case R.id.settings:
				// Avvvio activity Settings
				serverIntent = new Intent(this, Settings.class);
				startActivityForResult(serverIntent, 0);
				// Termino funzione
				return (true);
		}		// Chiusura switch seleziono voce men premuta
		return (false);
	}		// Chiusura funzione onOptionsItemSelected
}		// Chiusura classe Control