/****************************************************************
*  Name    : EthernetComunication								*
*  Author  : Davide Ferrario                                    *
*  Notice  : Copyright 2011 All Rights Reserved                 *
*  Date    : 13/05/2011                                         *
*  Notes   : Classe gestione comunicazione ethernet		    	*
*          :													*
****************************************************************/

// Definizione Package
package BlackProject.HouseSpeechDemo;

// Inclusione librerie
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URI;
import java.util.Date;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

// Definizione classe EthernetComunication
public class EthernetComunication {
	// Timestamp ultima trasmissione ethernet eseguita
	private static long TimeStamp_Ultima_Trasmissione = new Date(0).getTime();

	// Invia una richiesta HTTP alla scheda
	// INPUT:  	Stringa del comando (Es: "/index.htm?")
	// OUTPUT: 	Stringa risposta ricevuta
   	//				null -> invio richiesta FAULT
	// NOte:
	public synchronized static String Invia_Richiesta_Http (String Comando, boolean Flag_Wait_Risposta_Completa) {
		HttpClient httpClient = null;
		HttpGet httpGetRequest = null;
		HttpResponse httpResponse = null;
		BufferedReader bufferedReader = null;
		String Risposta = new String();

		// Se non passati circa 100 msec da ultima trasmissione
		if ((new Date().getTime() - TimeStamp_Ultima_Trasmissione) < 100) {
			// Attesa
	    	try {
	    		if ((100 - (new Date().getTime() - TimeStamp_Ultima_Trasmissione)) > 100)
	    			Thread.sleep (100 - (new Date().getTime() - TimeStamp_Ultima_Trasmissione));
	    		else
	    			Thread.sleep (100);
	    	} catch (Exception e) {}
    	}		// Chiusura if non passati circa 100 msec da ultima trasmissione

		// Gestisco comunicazione HTTP
		try {
			// Creo oggetto HttpClient
			httpClient = new DefaultHttpClient();
			// Creo oggetto HttpGet per inviare richiesta
			httpGetRequest = new HttpGet();
			// Creo oggetto URI della richiesta
			httpGetRequest.setURI (new URI("http://" + Utility.getIPAddressDestinatario() + ":" + Utility.getPortaTCP() + Comando));
			// Invio richiesta e attendo la risposta HTTP
			httpResponse = httpClient.execute (httpGetRequest);
			// Dalla risposta ottengo oggetto BufferedReader
			bufferedReader = new BufferedReader (new InputStreamReader (httpResponse.getEntity().getContent()));
			// Creo oggetto per lettura/conversione risposta
			StringBuffer stringBuffer = new StringBuffer("");
			String line = "";
			String NL = System.getProperty("line.separator");

    		// Se attendere risposta completa
    		if (Flag_Wait_Risposta_Completa == true) {
    			// Attendo risposta completa
    			for (int tentativi = 0;; tentativi++) {
	    			// Mentre disponibili nuovi caratteri
    				while ((line = bufferedReader.readLine()) != null) {
    					tentativi = 0;
    					stringBuffer.append (line + NL);
	    				// Converto ed ottengo Risposta completa
	    				Risposta = stringBuffer.toString();
	    			}		// Chiusura ciclo while mentre disponibili nuovi caratteri

    				// Se ricevuta risposta completa
	    			if (Risposta.contains("</response>") == true) {
	    				// Sostituisco tutti i caratteri "," con "."
	    				Risposta = Risposta.replace (",", ".");
	    				// Blocco ciclo for attendo risposta completa
	    				break;
	    			}		// Chiusura if ricevuta risposta completa

	    			// Se eseguiti 100 tentativi
	    			if (tentativi == 100) {
	    				// Azzero risposta
	    				Risposta = null;
	    				// Blocco ciclo for attendo risposta completa
	    				break;
	    			}		// Chiusura if eseguiti 100 tentativi

	    			// Attesa
					try {
						Thread.sleep (3);
					} catch (Exception e) {}
    			}		// Chiusura ciclo for attendo risposta completa
			}		// Chiusura if attendere risposta completa
    		// Se non attendere risposta completa
    		else {
				// Attendo almeno un carattere di risposta
    			for (int tentativi = 0;; tentativi++) {
    				// Se ricevuto carattere di risposta
    				if ((line = bufferedReader.readLine()) != null) {
    					Risposta = "Ok";
    					// Blocco ciclo for attendo almeno un carattere di risposta
    					break;
    				}		// Chiusura if ricevuto carattere di risposta

    				// Se eseguiti 100 tentativi
	    			if (tentativi == 100) {
	    				// Azzero risposta
	    				Risposta = null;
	    				// Blocco ciclo for attendo risposta completa
	    				break;
	    			}		// Chiusura if eseguiti 100 tentativi

	    			// Attesa
					try {
						Thread.sleep (3);
					} catch (Exception e) {}
    			}		// Chiusura ciclo for attendo almeno un carattere di risposta
    		}		// Chiusura else non attendere risposta completa
		}
		// Se errore nell'invio richiesta
		catch (Exception e) {
			// Azzero risposta
			Risposta = null;
		}
		finally {
        	if (bufferedReader != null) {
            	try {
            		bufferedReader.close();
                }
                catch (Exception e) {}
            }
		}
        // Aggiorno time stamp ultima trasmissione
        TimeStamp_Ultima_Trasmissione = new Date().getTime();

        // Aggiorno risultato ultima comunicazione ethernet
        if (Risposta == null)
        	StatoScheda.RisultatoUltimaComunicazione = false;
        else
        	StatoScheda.RisultatoUltimaComunicazione = true;

		// Ritorno risposta ricevuta
		return (Risposta);
	}		// Chiusura funzione Invia_Richiesta_Http
}		// Chiusura classe EthernetComunication