/****************************************************************
*  Name    : EthernetProtocol									*
*  Author  : Davide Ferrario                                    *
*  Notice  : Copyright 2011 All Rights Reserved                 *
*  Date    : 13/05/2011                                         *
*  Notes   : Classe gestione protocollo comunicazione ethernet 	*
*          : con la scheda										*
*          :													*
****************************************************************/

// Definizione Package
package BlackProject.HouseSpeechDemo;

// Inclusione librerie

// Definizione classe EthernetProtocol
public class EthernetProtocol {
	// Gestione avvio thread attivazione rele
	// INPUT:	Numero del rele da attivare (0,..,7)
	// OUTPUT:	-
	// Note:	-
	public void AttivazioneRele (byte ReleNum) {
		// Definizione classe Attivazione_Rele
		class Attivazione_Rele implements Runnable {
			private Thread Attivazione_Rele_Thread = null;
			private byte ReleNum;

			// Costruttore classe Attivazione_Rele
			private Attivazione_Rele (byte ReleNum) {
				this.ReleNum = ReleNum;
				Attivazione_Rele_Thread = new Thread(this);
				Attivazione_Rele_Thread.start();
			}		// Chiusura costruttore classe Attivazione_Rele

			// Funzione esecuzione comando
			public void run() {
				try {
					// Se esecuzione comando FAULT
					if (AttivaRele (ReleNum) == false)
						StatoScheda.StatoReleAttivo[ReleNum] = false;
					// Se esecuzione comando OK
					else
						StatoScheda.StatoReleAttivo[ReleNum] = true;
				} catch (Exception e) {}
			}		// Chiusura funzione run
		}		// Chiusura classe Attivazione_Rele
		
		// Eseguo attivazione rele
		new Attivazione_Rele(ReleNum);
	}		// Chiusura funzione AttivazioneRele
	
	// Gestione avvio thread disattivazione rele
	// INPUT:	Numero del rele da disattivare (0,..,7)
	// OUTPUT:	-
	// Note:	-
	public void DisattivazioneRele (byte ReleNum) {
		// Definizione classe Disattivazione_Rele
		class Disattivazione_Rele implements Runnable {
			private Thread Disattivazione_Rele_Thread = null;
			private byte ReleNum;

			// Costruttore classe Disattivazione_Rele
			private Disattivazione_Rele (byte ReleNum) {
				this.ReleNum = ReleNum;
				Disattivazione_Rele_Thread = new Thread(this);
				Disattivazione_Rele_Thread.start();
			}		// Chiusura costruttore classe Disattivazione_Rele

			// Funzione esecuzione comando
			public void run() {
				try {
					// Se esecuzione comando FAULT
					if (DisattivaRele (ReleNum) == false)
						StatoScheda.StatoReleAttivo[ReleNum] = true;
					// Se esecuzione comando OK
					else
						StatoScheda.StatoReleAttivo[ReleNum] = false;
				} catch (Exception e) {}
			}		// Chiusura funzione run
		}		// Chiusura classe Disattivazione_Rele
		
		// Eseguo disattivazione rele
		new Disattivazione_Rele(ReleNum);
	}		// Chiusura funzione DisattivazioneRele

	// Gestione avvio thread inversione rele
	// INPUT:	Numero del rele da invertire (0,..,7)
	// OUTPUT:	-
	// Note:	-
	public void InversioneRele (byte ReleNum) {
		// Definizione classe Inversione_Rele
		class Inversione_Rele implements Runnable {
			private Thread Inversione_Rele_Thread = null;
			private byte ReleNum;

			// Costruttore classe Inversione_Rele
			private Inversione_Rele (byte ReleNum) {
				this.ReleNum = ReleNum;
				Inversione_Rele_Thread = new Thread(this);
				Inversione_Rele_Thread.start();
			}		// Chiusura costruttore classe Inversione_Rele

			// Funzione esecuzione comando
			public void run() {
				try {
					// Se esecuzione comando OK
					if (InvertiRele (ReleNum) == true)
						StatoScheda.StatoReleAttivo[ReleNum] = (!(StatoScheda.StatoReleAttivo[ReleNum]));
				} catch (Exception e) {}
			}		// Chiusura funzione run
		}		// Chiusura classe Inversione_Rele
		
		// Eseguo inversione rele
		new Inversione_Rele(ReleNum);
	}		// Chiusura funzione InversioneRele
	
	// Richiede l'esecuzione dell'attivazione di un rele
	// INPUT:	Numero del rele da attivare (0,..,7)
	// OUTPUT:	Risultato esecuzione
	// 				false -> esecuzione FAULT
	//				true -> esecuzione OK
	// Note:	-
	private boolean AttivaRele (byte ReleNumber) {
		// Eseguo comando
		String Risposta = EthernetComunication.Invia_Richiesta_Http ("/forms.htm?led" + ReleNumber + "=1", false);
		
		// Se non ricevuta risposta comando
		if (Risposta == null)
			// Esecuzione FAULT
			return (false);
		// Se ricevuta risposta comando
		else
			// Esecuzione OK
			return (true);
	}		// Chiusura funzione AttivaRele

	// Richiede l'esecuzione della disattivazione di un rele
	// INPUT:	Numero del rele da disattivare (0,..,7)
	// OUTPUT:	Risultato esecuzione
	// 				false -> esecuzione FAULT
	//				true -> esecuzione OK
	// Note:	-
	private boolean DisattivaRele (byte ReleNumber) {
		// Eseguo comando
		String Risposta = EthernetComunication.Invia_Richiesta_Http ("/forms.htm?led" + ReleNumber + "=0", false);
			
		// Se non ricevuta risposta comando
		if (Risposta == null)
			// Esecuzione FAULT
			return (false);
		// Se ricevuta risposta comando
		else
			// Esecuzione OK
			return (true);
	}		// Chiusura funzione DisattivaRele

	// Richiede l'esecuzione dell'inversione di un rele
	// INPUT:	Numero del rele da invertire (0,..,7)
	// OUTPUT:	Risultato esecuzione
	// 				false -> esecuzione FAULT
	//				true -> esecuzione OK
	// Note:	-
	private boolean InvertiRele (byte ReleNumber) {
		// Eseguo comando
		String Risposta = EthernetComunication.Invia_Richiesta_Http ("/leds.cgi?led=" + ReleNumber, false);
			
		// Se non ricevuta risposta comando
		if (Risposta == null)
			// Esecuzione FAULT
			return (false);
		// Se ricevuta risposta comando
		else
			// Esecuzione OK
			return (true);
	}		// Chiusura funzione InvertiRele

	// Richiede l'esecuzione della lettura dello stato scheda (file status.xml)
	// INPUT:	-
	// OUTPUT:	Risposta lettura
	// 				null -> esecuzione FAULT
	//				Stringa risposta -> esecuzione OK
	// Note:	-
	public String LetturaStatoScheda() {
		// Eseguo comando
		String Risposta = EthernetComunication.Invia_Richiesta_Http ("/status.xml", true);
		
		// Ritorno la risposta
		return (Risposta);
	}		// Chiusura funzione LetturaStatoScheda
}		// Chiusura classe EthernetProtocol